package com.example.android.db;

import android.app.Activity;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteStatement;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.AdapterView.OnItemSelectedListener;

public class Main extends Activity {
	
	private DatabaseHelper helper;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		helper = new DatabaseHelper(this);
		final SQLiteDatabase db = helper.getReadableDatabase();
		
		Cursor c = db.query("capitals", new String[] {"prefecture"}, null, null, null, null, null);
		c.moveToFirst();
		
		CharSequence[] list = new CharSequence[c.getCount()];
		for (int i = 0; i < list.length; i++) {
			list[i] = c.getString(0);
			c.moveToNext();
		}
		c.close();
		
		Spinner spinner = (Spinner)findViewById(R.id.Spinner01);
		spinner.setAdapter(new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item, list));
		spinner.setOnItemSelectedListener(new OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
				String prefecture = ((Spinner)parent).getSelectedItem().toString();
				Cursor c;
				
				c = db.query("capitals", new String[] {"capital"}, "prefecture='" + prefecture + "'", null, null, null, null);
				c.moveToFirst();
				String capital = c.getString(0);
				c.close();
				
				TextView textView = (TextView)findViewById(R.id.TextView01);
				textView.setText(capital);
				
				c = db.query("local_dishes", new String[] {"local_dish"}, "prefecture='" + prefecture + "'", null, null, null, null);
				c.moveToFirst();
				CharSequence[] list = new CharSequence[c.getCount()];
				for (int i = 0; i < list.length; i++) {
					list[i] = c.getString(0);
					c.moveToNext();
				}
				c.close();
				ArrayAdapter<CharSequence> adapter = new ArrayAdapter<CharSequence>(Main.this, android.R.layout.simple_list_item_1, list);
				ListView listView = (ListView)findViewById(R.id.ListView01);
				listView.setAdapter(adapter);
			}

			@Override
			public void onNothingSelected(AdapterView<?> parent) {
			}
			
		});
		
	}
	
	@Override
	protected void onDestroy() {
		super.onDestroy();
		helper.close();
	}
	
	class DatabaseHelper extends SQLiteOpenHelper {

		private String[][] CAPITALS = {
			{"kC", "Dy"},
			{"X", "X"},
			{"茧", ""},
			{"{錧", ""},
			{"Hc", "Hc"},
			{"R`", "R`"},
			{"", ""},
			{"錧", ""},
			{"Ȗ،", "Fs{"},
			{"Qn", "O"},
			{"ʌ", ""},
			{"t", "t"},
			{"s", "Vh"},
			{"_ސ쌧", "l"},
			{"V", "V"},
			{"xR", "xR"},
			{"ΐ쌧", ""},
			{"䌧", ""},
			{"R", "b{"},
			{"쌧", ""},
			{"򕌌", ""},
			{"É", "É"},
			{"m", "É"},
			{"Od", ""},
			{"ꌧ", ""},
			{"s{", "s"},
			{"{", ""},
			{"Ɍ", "_"},
			{"ޗǌ", "ޗ"},
			{"a̎R", "a̎R"},
			{"挧", ""},
			{"", "]"},
			{"R", "R"},
			{"L", "L"},
			{"R", "R"},
			{"", ""},
			{"쌧", ""},
			{"Q", "R"},
			{"m", "m"},
			{"", ""},
			{"ꌧ", ""},
			{"茧", ""},
			{"F{", "F{"},
			{"啪", "啪"},
			{"{茧", "{"},
			{"", ""},
			{"ꌧ", "ߔe"},
		};
		
		private String[][] LOCAL_DISHES = {
			{"Od", ""},
			{"Od", "Ăˎi"},
			{"Ɍ", "΂߂"},
			{"Ɍ", ""},
			{"kC", "߂"},
			{"kC", "̂"},
			{"kC", ""},
			{"kC", "CJ"},
			{"kC", "GXJbv"},
			{"kC", "WMXJ"},
			{"kC", "``Ă"},
			{"kC", "`[Y肢cq"},
			{"kC", "Cx"},
			{"kC", "Ύ"},
			{"kC", "ؘ"},
			{"t", "߂"},
			{"t", "₦ǂ̗Ƃ"},
			{"t", "񂪏Ă"},
			{"t", "Ƃ`"},
			{"t", "Ȃ߂낤"},
			{"t", "s[ibcX"},
			{"t", "؂̉Ԃ̐hqa"},
			{"a̎R", "~т"},
			{"ʌ", "˂ʂ"},
			{"ʌ", "[[tC"},
			{"啪", "炷܂߂"},
			{"啪", "炫"},
			{"啪", "񂲏`"},
			{"啪", "ƂV"},
			{"啪", "₹"},
			{"啪", "{̂g"},
			{"{", "DݏĂ"},
			{"{", "c"},
			{"{", "D`"},
			{"ޗǌ", "і"},
			{"ޗǌ", ""},
			{"ޗǌ", "򒹓"},
			{"{錧", ""},
			{"{錧", "񂾖"},
			{"{錧", "͂炱"},
			{"{錧", "΂X"},
			{"{錧", "ق̐|̕"},
			{"{錧", "X"},
			{"{錧", "R؂"},
			{"{錧", "^"},
			{"{錧", ""},
			{"{茧", "˂肭"},
			{"{茧", "`L"},
			{"{茧", "`"},
			{"xR", "Ԃ卪"},
			{"xR", "ׂ"},
			{"xR", "₿"},
			{"xR", "CJ̍"},
			{"R", "񂿂傤"},
			{"R", ""},
			{"R`", "R`̂"},
			{"R`", "}͂"},
			{"R`", "ʂɂႭ"},
			{"R`", "[`"},
			{"R`", ""},
			{"R", "قƂ"},
			{"茧", "݂傤"},
			{"茧", ""},
			{"茧", ""},
			{"茧", ""},
			{"茧", "s킩߂̃||傤"},
			{"茧", "cy"},
			{"L", "̂"},
			{"L", "y̓y"},
			{"Q", "傤"},
			{"Q", "Ђイ"},
			{"Q", "߂"},
			{"m", "Ђ܂Ԃ "},
			{"m", "XJc"},
			{"m", "Xύ݂ǂ"},
			{"m", "H̓g"},
			{"V", "݂"},
			{"V", "Ԃ"},
			{"V", "񂳏Ă"},
			{"V", "卪̂҂"},
			{"V", ""},
			{"V", "̏ĕt"},
			{"s", "˂ܓ"},
			{"s", "["},
			{"Ȗ،", "Ƃ"},
			{"Ȗ،", "tC"},
			{"Ȗ،", "҂傤̗Ƃ"},
			{"Ȗ،", "卪"},
			{"Ȗ،", "@x`"},
			{"Ȗ،", "̂"},
			{"Ȗ،", "{˂Ǝ|"},
			{"ꌧ", "т"},
			{"ꌧ", "ɂ񂶂񂵂肵"},
			{"ꌧ", "NNV"},
			{"ꌧ", "S[`v["},
			{"ꌧ", "\[~`v["},
			{"ꌧ", "q[`"},
			{"ꌧ", "~k_"},
			{"F{", "؂߂"},
			{"ΐ쌧", "Ȃ߂"},
			{"ΐ쌧", "ጩ"},
			{"_ސ쌧", "炷"},
			{"", "ߎ"},
			{"", "Ăǂ"},
			{"", "CJlQ"},
			{"", "؂肱ԂƖg̎ϕ"},
			{"", ""},
			{"Hc", "肽"},
			{"Hc", ""},
			{"Qn", "ɂႭ̂҂"},
			{"Qn", "卪"},
			{"錧", "ڂ["},
			{"錧", "ARÊƂ|"},
			{"茧", "qJh"},
			{"쌧", "₫"},
			{"쌧", "ɂ点ׂ"},
			{"쌧", "₽"},
			{"X", "̏`"},
			{"X", "܂݂"},
			{"X", "قĂ̊LĂX"},
			{"X", "Ă"},
			{"X", ""},
			{"쌧", "̂҂"},
			{"쌧", "CR"},
			{"m", "֎q̂"},
			{"m", "̓y"},
			{"挧", "̂̂"},
			{"", "t"},
			{"", "܂"},
			{"", "܏`"},
			{"", "ɂ̖u"},
			{"", "߂"},
			{"", "{"},
		};
		
		public DatabaseHelper(Context context) {
			super(context, null, null, 1);
		}
		
		@Override
		public void onCreate(SQLiteDatabase db) {
			db.beginTransaction();
			try {
				SQLiteStatement stmt;
				db.execSQL("create table capitals (prefecture text primary key, capital text not null);");
				stmt = db.compileStatement("insert into capitals values (?, ?);");
				
				for (String[] capital : CAPITALS) {
					stmt.bindString(1, capital[0]);
					stmt.bindString(2, capital[1]);
					stmt.executeInsert();
				}
				
				db.execSQL("create table local_dishes (prefecture text not null, local_dish text not null);");
				stmt = db.compileStatement("insert into local_dishes values (?, ?);");
				
				for (String[] localDish : LOCAL_DISHES) {
					stmt.bindString(1, localDish[0]);
					stmt.bindString(2, localDish[1]);
					stmt.executeInsert();
				}
				db.setTransactionSuccessful();
			} finally {
				db.endTransaction();
			}
		}

		@Override
		public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		}
		
	}
	
}